<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: testehrhart.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>testehrhart.c</h1><a href="testehrhart_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/***********************************************************************/</span>
<a name="l00002"></a>00002 <span class="comment">/*                Ehrhart V4.20                                        */</span>
<a name="l00003"></a>00003 <span class="comment">/*                copyright 1997, Doran Wilde                          */</span>
<a name="l00004"></a>00004 <span class="comment">/*                copyright 1997-2000, Vincent Loechner                */</span>
<a name="l00005"></a>00005 <span class="comment">/*       Permission is granted to copy, use, and distribute            */</span>
<a name="l00006"></a>00006 <span class="comment">/*       for any commercial or noncommercial purpose under the terms   */</span>
<a name="l00007"></a>00007 <span class="comment">/*       of the GNU General Public license, version 2, June 1991       */</span>
<a name="l00008"></a>00008 <span class="comment">/*       (see file : LICENSING).                                       */</span>
<a name="l00009"></a>00009 <span class="comment">/***********************************************************************/</span>
<a name="l00010"></a>00010 <span class="comment">/*</span>
<a name="l00011"></a>00011 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00012"></a>00012 <span class="comment"></span>
<a name="l00013"></a>00013 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00014"></a>00014 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00015"></a>00015 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00016"></a>00016 <span class="comment">    (at your option) any later version.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00019"></a>00019 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00020"></a>00020 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00021"></a>00021 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00022"></a>00022 <span class="comment"></span>
<a name="l00023"></a>00023 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00024"></a>00024 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00025"></a>00025 <span class="comment">*/</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;ctype.h&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;unistd.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;<a class="code" href="assert_8h.html">assert.h</a>&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;<a class="code" href="homogenization_8h.html">polylib/homogenization.h</a>&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;config.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="testehrhart_8c.html#a995bc50ed450a1f0b16b6a26a845991f">00038</a> <span class="preprocessor">#define EP_EVALUATION</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="preprocessor">#ifndef HAVE_GETOPT_H</span>
<a name="l00041"></a><a class="code" href="testehrhart_8c.html#a1e2dfa3e09e21872dcebe9928e1c6f83">00041</a> <span class="preprocessor"></span><span class="preprocessor">#define getopt_long(a,b,c,d,e) getopt(a,b,c)</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#include &lt;getopt.h&gt;</span>
<a name="l00044"></a>00044 <span class="keyword">struct </span>option options[] = {
<a name="l00045"></a>00045     { <span class="stringliteral">&quot;homogenized&quot;</span>,   no_argument,  0,  <span class="charliteral">&apos;h&apos;</span> },
<a name="l00046"></a>00046     { 0, 0, 0, 0 }
<a name="l00047"></a>00047 };
<a name="l00048"></a>00048 <span class="preprocessor">#endif</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a><a class="code" href="testehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">00050</a> <span class="preprocessor">#define WS 0</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="comment"></span>
<a name="l00052"></a>00052 <span class="comment">/** </span>
<a name="l00053"></a>00053 <span class="comment">    </span>
<a name="l00054"></a>00054 <span class="comment">define this to print all constraints on the validity domains if not</span>
<a name="l00055"></a>00055 <span class="comment">defined, only new constraints (not in validity domain given by the</span>
<a name="l00056"></a>00056 <span class="comment">user) are printed</span>
<a name="l00057"></a>00057 <span class="comment"></span>
<a name="l00058"></a>00058 <span class="comment">*/</span>
<a name="l00059"></a><a class="code" href="testehrhart_8c.html#ade591ac8b3c36da1f2115f2dcaa1f75c">00059</a> <span class="preprocessor">#define EPRINT_ALL_VALIDITY_CONSTRAINTS</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="comment"></span>
<a name="l00061"></a>00061 <span class="comment">/** </span>
<a name="l00062"></a>00062 <span class="comment"></span>
<a name="l00063"></a>00063 <span class="comment">The following are mainly for debug purposes. You shouldn&apos;t need to</span>
<a name="l00064"></a>00064 <span class="comment">change anything for daily usage...</span>
<a name="l00065"></a>00065 <span class="comment"></span>
<a name="l00066"></a>00066 <span class="comment">*/</span>
<a name="l00067"></a>00067 <span class="comment"></span>
<a name="l00068"></a>00068 <span class="comment">/** you may define each macro independently </span>
<a name="l00069"></a>00069 <span class="comment">&lt;ol&gt;</span>
<a name="l00070"></a>00070 <span class="comment">&lt;li&gt; #define EDEBUG minimal debug </span>
<a name="l00071"></a>00071 <span class="comment">&lt;li&gt; #define EDEBUG1 prints enumeration points</span>
<a name="l00072"></a>00072 <span class="comment">&lt;li&gt; #define EDEBUG11 prints number of points</span>
<a name="l00073"></a>00073 <span class="comment">&lt;li&gt; #define EDEBUG2 prints domains</span>
<a name="l00074"></a>00074 <span class="comment">&lt;li&gt; #define EDEBUG21 prints more domains</span>
<a name="l00075"></a>00075 <span class="comment">&lt;li&gt; #define EDEBUG3 prints systems of equations that are solved</span>
<a name="l00076"></a>00076 <span class="comment">&lt;li&gt; #define EDEBUG4 prints message for degree reduction</span>
<a name="l00077"></a>00077 <span class="comment">&lt;li&gt; #define EDEBUG5 prints result before simplification </span>
<a name="l00078"></a>00078 <span class="comment">&lt;li&gt; #define EDEBUG6 prints domains in Preprocess </span>
<a name="l00079"></a>00079 <span class="comment">&lt;li&gt; #define EDEBUG61 prints even more in Preprocess</span>
<a name="l00080"></a>00080 <span class="comment">&lt;li&gt; #define EDEBUG62 prints domains in Preprocess2</span>
<a name="l00081"></a>00081 <span class="comment">&lt;/ol&gt;</span>
<a name="l00082"></a>00082 <span class="comment">*/</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="comment">/* #define EDEBUG       */</span>              <span class="comment">/* minimal debug */</span>
<a name="l00085"></a>00085 <span class="comment">/* #define EDEBUG1      */</span>              <span class="comment">/* prints enumeration points */</span>
<a name="l00086"></a>00086 <span class="comment">/* #define EDEBUG11     */</span>              <span class="comment">/* prints number of points */</span>
<a name="l00087"></a>00087 <span class="comment">/* #define EDEBUG2      */</span>              <span class="comment">/* prints domains */</span>
<a name="l00088"></a>00088 <span class="comment">/* #define EDEBUG21     */</span>              <span class="comment">/* prints more domains */</span>
<a name="l00089"></a>00089 <span class="comment">/* #define EDEBUG3      */</span>              <span class="comment">/* prints systems of equations that are solved */</span>
<a name="l00090"></a>00090 <span class="comment">/* #define EDEBUG4      */</span>              <span class="comment">/* prints message for degree reduction */</span>
<a name="l00091"></a>00091 <span class="comment">/* #define EDEBUG5      */</span>              <span class="comment">/* prints result before simplification */</span>
<a name="l00092"></a>00092 <span class="comment">/* #define EDEBUG6      */</span>              <span class="comment">/* prints domains in Preprocess */</span>
<a name="l00093"></a>00093 <span class="comment">/* #define EDEBUG61     */</span>              <span class="comment">/* prints even more in Preprocess */</span>
<a name="l00094"></a>00094 <span class="comment">/* #define EDEBUG62     */</span>              <span class="comment">/* prints domains in Preprocess2 */</span>
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="comment"></span>
<a name="l00097"></a>00097 <span class="comment">/**</span>
<a name="l00098"></a>00098 <span class="comment"></span>
<a name="l00099"></a>00099 <span class="comment"> Reduce the degree of resulting polynomials</span>
<a name="l00100"></a>00100 <span class="comment"></span>
<a name="l00101"></a>00101 <span class="comment">*/</span>
<a name="l00102"></a><a class="code" href="testehrhart_8c.html#ab33c076ab65d4d23c5a4f6a496b0aefb">00102</a> <span class="preprocessor">#define REDUCE_DEGREE</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span><span class="comment"></span>
<a name="l00104"></a>00104 <span class="comment">/** </span>
<a name="l00105"></a>00105 <span class="comment"></span>
<a name="l00106"></a>00106 <span class="comment">define this to print one warning message per domain overflow these</span>
<a name="l00107"></a>00107 <span class="comment">overflows should no longer happen since version 4.20</span>
<a name="l00108"></a>00108 <span class="comment"></span>
<a name="l00109"></a>00109 <span class="comment">*/</span>
<a name="l00110"></a><a class="code" href="testehrhart_8c.html#ab82d76b3dd0632715d69af9117f9c6ed">00110</a> <span class="preprocessor">#define ALL_OVERFLOW_WARNINGS</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span><span class="comment"></span>
<a name="l00112"></a>00112 <span class="comment">/**</span>
<a name="l00113"></a>00113 <span class="comment"></span>
<a name="l00114"></a>00114 <span class="comment">EPRINT : print results while computing the ehrhart polynomial.  this</span>
<a name="l00115"></a>00115 <span class="comment">is done by default if you build the executable ehrhart.  (If EMAIN is</span>
<a name="l00116"></a>00116 <span class="comment">defined).  Don&apos;t define EMAIN here, it is defined when necessary in</span>
<a name="l00117"></a>00117 <span class="comment">the makefile.  </span>
<a name="l00118"></a>00118 <span class="comment"></span>
<a name="l00119"></a>00119 <span class="comment">&lt;p&gt;</span>
<a name="l00120"></a>00120 <span class="comment"></span>
<a name="l00121"></a>00121 <span class="comment">Notice: you may however define EPRINT without defining EMAIN, but in</span>
<a name="l00122"></a>00122 <span class="comment">this case, you have to initialize the global variable param_name by</span>
<a name="l00123"></a>00123 <span class="comment">calling Read_ParamNames before any call to ehrhart.  This is NOT</span>
<a name="l00124"></a>00124 <span class="comment">recommanded, unless you know what you do.  EPRINT causes more debug</span>
<a name="l00125"></a>00125 <span class="comment">messages to be printed.</span>
<a name="l00126"></a>00126 <span class="comment"></span>
<a name="l00127"></a>00127 <span class="comment">*/</span>
<a name="l00128"></a>00128 <span class="comment">/* #define EPRINT */</span>
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="testehrhart_8c.html#a3c04138a5bfe5d72780bb7e82a18e627">00130</a> <span class="keywordtype">int</span> <a class="code" href="c2p_8c.html#ae66f6b31b5ad750f1fe042a706a4e3d4">main</a>(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> **argv)
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132     <span class="keywordtype">int</span> i;
<a name="l00133"></a>00133     <span class="keywordtype">char</span> str[1024];
<a name="l00134"></a>00134     <a class="code" href="structmatrix.html">Matrix</a> *C1, *P1;
<a name="l00135"></a>00135     <a class="code" href="structpolyhedron.html">Polyhedron</a> *C, *P;
<a name="l00136"></a>00136     <a class="code" href="struct__enumeration.html">Enumeration</a> *en;
<a name="l00137"></a>00137     <span class="keyword">const</span> <span class="keywordtype">char</span> **param_name;
<a name="l00138"></a>00138     <span class="keywordtype">int</span> c, ind = 0;
<a name="l00139"></a>00139     <span class="keywordtype">int</span> hom = 0;
<a name="l00140"></a>00140   
<a name="l00141"></a>00141 <span class="preprocessor">#ifdef EP_EVALUATION</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span>    Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, *tmp;
<a name="l00143"></a>00143     <span class="keywordtype">int</span> k;
<a name="l00144"></a>00144 <span class="preprocessor">#endif</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>
<a name="l00146"></a>00146     <span class="keywordflow">while</span> ((c = <a class="code" href="testehrhart_8c.html#a1e2dfa3e09e21872dcebe9928e1c6f83">getopt_long</a>(argc, argv, <span class="stringliteral">&quot;h&quot;</span>, options, &amp;ind)) != -1) {
<a name="l00147"></a>00147         <span class="keywordflow">switch</span> (c) {
<a name="l00148"></a>00148         <span class="keywordflow">case</span> <span class="charliteral">&apos;h&apos;</span>:
<a name="l00149"></a>00149             hom = 1;
<a name="l00150"></a>00150             <span class="keywordflow">break</span>;
<a name="l00151"></a>00151         }
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154     P1 = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00155"></a>00155     C1 = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00156"></a>00156     <span class="keywordflow">if</span>(C1-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> &lt; 2) {
<a name="l00157"></a>00157         fprintf( stderr, <span class="stringliteral">&quot;Not enough parameters !\n&quot;</span> );
<a name="l00158"></a>00158         exit(0);
<a name="l00159"></a>00159     }
<a name="l00160"></a>00160     <span class="keywordflow">if</span> (hom) {
<a name="l00161"></a>00161         <a class="code" href="structmatrix.html">Matrix</a> *C2, *P2;
<a name="l00162"></a>00162         P2 = <a class="code" href="Matop_8c.html#a7d43e9c44b8c49cd9a542102042ad72e">AddANullColumn</a>(P1);
<a name="l00163"></a>00163         <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(P1);
<a name="l00164"></a>00164         P1 = P2;
<a name="l00165"></a>00165         C2 = <a class="code" href="Matop_8c.html#a7d43e9c44b8c49cd9a542102042ad72e">AddANullColumn</a>(C1);
<a name="l00166"></a>00166         <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(C1);
<a name="l00167"></a>00167         C1 = C2;
<a name="l00168"></a>00168     }
<a name="l00169"></a>00169     P = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(P1,<a class="code" href="ext__ehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00170"></a>00170     C = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(C1,<a class="code" href="ext__ehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00171"></a>00171     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(P1);
<a name="l00172"></a>00172     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(C1);
<a name="l00173"></a>00173   
<a name="l00174"></a>00174     <span class="comment">/* Read the name of the parameters */</span>
<a name="l00175"></a>00175     param_name = <a class="code" href="param_8c.html#ac5f556f34173ebc8815247ee7f4e2a0b">Read_ParamNames</a>(stdin,C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a> - hom);
<a name="l00176"></a>00176     <span class="keywordflow">if</span> (hom) {
<a name="l00177"></a>00177         <span class="keyword">const</span> <span class="keywordtype">char</span> **param_name2;
<a name="l00178"></a>00178         param_name2 = (<span class="keyword">const</span> <span class="keywordtype">char</span>**)malloc(<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>*) * (C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>));
<a name="l00179"></a>00179         <span class="keywordflow">for</span> (i = 0; i &lt; C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a> - 1; i++)
<a name="l00180"></a>00180             param_name2[i] = param_name[i];
<a name="l00181"></a>00181         param_name2[C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-1] = <span class="stringliteral">&quot;_H&quot;</span>;
<a name="l00182"></a>00182         free(param_name);
<a name="l00183"></a>00183         param_name=param_name2;
<a name="l00184"></a>00184     }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186     en = <a class="code" href="ehrhart_8c.html#a3c3e442b1d2c924f03f02f9e9283141a" title="Procedure to count points in a parameterized polytope.">Polyhedron_Enumerate</a>(P,C,<a class="code" href="ext__ehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>,param_name);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordflow">if</span> (hom) {
<a name="l00189"></a>00189         <a class="code" href="struct__enumeration.html">Enumeration</a> *en2;
<a name="l00190"></a>00190 
<a name="l00191"></a>00191         printf(<span class="stringliteral">&quot;inhomogeneous form:\n&quot;</span>);
<a name="l00192"></a>00192       
<a name="l00193"></a>00193         <a class="code" href="homogenization_8c.html#a06456b946001b8ddaf7203de4856abd7" title="dehomogenize an enumeration.">dehomogenize_enumeration</a>(en, C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>, <a class="code" href="ext__ehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00194"></a>00194         <span class="keywordflow">for</span> (en2 = en; en2; en2 = en2-&gt;<a class="code" href="struct__enumeration.html#ad2fd42474e015c9abc6aea0e2bea08b8">next</a>) {
<a name="l00195"></a>00195             <a class="code" href="polyparam_8c.html#afa315bc856959f9a781359f69b74d7a4">Print_Domain</a>(stdout, en2-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>, param_name);
<a name="l00196"></a>00196             <a class="code" href="ehrhart_8c.html#a99718adf05e065181f35f5ca847f94b0">print_evalue</a>(stdout, &amp;en2-&gt;<a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>, param_name);
<a name="l00197"></a>00197         }
<a name="l00198"></a>00198     }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="preprocessor">#ifdef EP_EVALUATION</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>    <span class="keywordflow">if</span>( isatty(0) &amp;&amp; C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a> != 0)
<a name="l00202"></a>00202         {  <span class="comment">/* no tty input or no polyhedron -&gt; no evaluation. */</span>
<a name="l00203"></a>00203             printf(<span class="stringliteral">&quot;Evaluation of the Ehrhart polynomial :\n&quot;</span>);
<a name="l00204"></a>00204             p = (Value *)malloc(<span class="keyword">sizeof</span>(Value) * (C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>));
<a name="l00205"></a>00205             <span class="keywordflow">for</span>(i=0;i&lt;C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>;i++) 
<a name="l00206"></a>00206                 <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(p[i]);
<a name="l00207"></a>00207             <a class="code" href="types_8h.html#a75c828ed6c02fcd44084e67a032e422c">FOREVER</a> {
<a name="l00208"></a>00208                 fflush(stdin);
<a name="l00209"></a>00209                 printf(<span class="stringliteral">&quot;Enter %d parameters : &quot;</span>,C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>);
<a name="l00210"></a>00210                 <span class="keywordflow">for</span>(k=0;k&lt;C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>;++k) {
<a name="l00211"></a>00211                     scanf(<span class="stringliteral">&quot;%s&quot;</span>,str);
<a name="l00212"></a>00212                     <a class="code" href="source_2arith_2arithmetique_8h.html#ab8a77ddf3765fd598f31d8ca2ac4705c">value_read</a>(p[k],str);
<a name="l00213"></a>00213                 }
<a name="l00214"></a>00214                 fprintf(stdout,<span class="stringliteral">&quot;EP( &quot;</span>);
<a name="l00215"></a>00215                 <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,p[0]);
<a name="l00216"></a>00216                 <span class="keywordflow">for</span>(k=1;k&lt;C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>;++k) {
<a name="l00217"></a>00217                     fprintf(stdout,<span class="stringliteral">&quot;,&quot;</span>);
<a name="l00218"></a>00218                     <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,p[k]);
<a name="l00219"></a>00219                 }  
<a name="l00220"></a>00220                 fprintf(stdout,<span class="stringliteral">&quot; ) = &quot;</span>);
<a name="l00221"></a>00221                 <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,*(tmp=<a class="code" href="eval__ehrhart_8c.html#af970e7f69cbf548188a8f3754001a150">compute_poly</a>(en,p)));
<a name="l00222"></a>00222                 free(tmp);
<a name="l00223"></a>00223                 fprintf(stdout,<span class="stringliteral">&quot;\n&quot;</span>);  
<a name="l00224"></a>00224             }
<a name="l00225"></a>00225         }
<a name="l00226"></a>00226 <span class="preprocessor">#endif </span><span class="comment">/* EP_EVALUATION */</span>
<a name="l00227"></a>00227   
<a name="l00228"></a>00228     <a class="code" href="ehrhart_8c.html#aeaadcf4c2404d688eb1443486ad8becb">Enumeration_Free</a>(en);
<a name="l00229"></a>00229     <a class="code" href="param_8c.html#ae85c395031b2feb7cc47ba691bb6392f">Free_ParamNames</a>(param_name, C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-hom);
<a name="l00230"></a>00230     <a class="code" href="polyhedron_8c.html#a4ae97b9794e3a616f1d38c68e6515cc3">Polyhedron_Free</a>( P );
<a name="l00231"></a>00231     <a class="code" href="polyhedron_8c.html#a4ae97b9794e3a616f1d38c68e6515cc3">Polyhedron_Free</a>( C );
<a name="l00232"></a>00232 
<a name="l00233"></a>00233     <span class="keywordflow">return</span> 0;
<a name="l00234"></a>00234 }
<a name="l00235"></a>00235 
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
